install: mkfifo only if the file is not fifo yet
[girocco.git] / install.sh
blobc8ad84b5c26f405595295671f317f02d34b57898
1 #!/bin/sh
2 # The Girocco installation script
3 # We will OVERWRITE basedir!
5 set -e
7 # What Config should we use?
8 [ -n "$GIROCCO_CONF" ] || GIROCCO_CONF=Girocco::Config
9 echo "*** Initializing using $GIROCCO_CONF..."
11 # First run Girocco::Config consistency checks
12 perl -I. -M$GIROCCO_CONF -e ''
14 . ./shlib.sh
16 owngroup=""
17 [ -z "$cfg_owning_group" ] || owngroup=".$cfg_owning_group"
20 echo "*** Setting up basedir..."
21 rm -fr "$cfg_basedir"
22 mkdir -p "$cfg_basedir"
23 cp -a Girocco jobd taskd fixupd gitweb html jobs toolbox hooks apache.conf shlib.sh "$cfg_basedir"
25 # Put the correct Config in place
26 [ "$GIROCCO_CONF" = "Girocco::Config" ] || cp "$(echo "$GIROCCO_CONF" | sed 's#::#/#g; s/$/.pm/')" "$cfg_basedir/Girocco/Config.pm"
29 echo "*** Preprocessing scripts..."
30 perl -I. -M$GIROCCO_CONF -i -pe 's/\@basedir\@/"$Girocco::Config::basedir"/g' "$cfg_basedir"/jobs/*.sh "$cfg_basedir"/jobd/*.sh "$cfg_basedir"/taskd/*.sh "$cfg_basedir"/gitweb/*.sh "$cfg_basedir"/shlib.sh "$cfg_basedir"/hooks/*
33 if [ -n "$cfg_mirror" ]; then
34 echo "--- Remember to start $cfg_basedir/taskd/taskd.pl"
36 if [ -n "$cfg_push" -a "$cfg_permission_control" = "Group" ]; then
37 echo "Creating FIFO for fixupd: $cfg_fixup_queue"
38 [ -p "$cfg_fixup_queue" ] || mkfifo "$cfg_fixup_queue"
39 chown "$cfg_cgi_user""$owngroup" "$cfg_fixup_queue" ||
40 echo "WARNING: Cannot chown $cfg_cgi_user.$cfg_owning_group $cfg_fixup_queue"
41 echo "--- Remember to copy $cfg_basedir/fixupd/ to /root and start fixupd.sh as root"
43 echo "--- Also remember to either start $cfg_basedir/jobd/jobd.sh, or add this"
44 echo "--- to the crontab of $cfg_mirror_user (adjust frequency on number of repos):"
45 echo "*/30 * * * * /usr/bin/nice -n 18 $cfg_basedir/jobd/jobd.sh -q --all-once"
48 echo "*** Setting up repository root..."
49 mkdir -p "$cfg_reporoot"
50 if [ "$cfg_owning_group" ]; then
51 chown ."$cfg_owning_group" "$cfg_reporoot" || echo "WARNING: Cannot chgrp $cfg_owning_group $cfg_reporoot"
53 chmod a+rwx,g+s,o+t "$cfg_reporoot" || echo "WARNING: Cannot chmod $cfg_reporoot properly"
56 if [ -n "$cfg_chrooted" ]; then
57 echo "*** Setting up chroot jail for pushing..."
58 if [ "$(id -u)" -eq 0 ]; then
59 ./jailsetup.sh
60 else
61 echo "WARNING: Skipping jail setup, not root"
66 echo "*** Setting up jail configuration (project database)..."
67 mkdir -p "$cfg_chroot" "$cfg_chroot/etc"
68 touch "$cfg_chroot/etc/passwd" "$cfg_chroot/etc/group"
69 chown "$cfg_cgi_user""$owngroup" "$cfg_chroot/etc" ||
70 echo "WARNING: Cannot chown $cfg_cgi_user.$cfg_owning_group the files"
71 chmod 02775 "$cfg_chroot/etc" || echo "WARNING: Cannot chmod 02775 $cfg_chroot/etc"
74 echo "*** Setting up gitweb from git.git..."
75 if [ ! -f git.git/Makefile ]; then
76 echo "ERROR: git.git is not checked out! Did you _REALLY_ read INSTALL?" >&2
77 exit 1;
79 mkdir -p "$cfg_webroot" "$cfg_cgiroot"
80 (cd git.git && make --quiet gitweb/gitweb.cgi && cp gitweb/gitweb.cgi "$cfg_cgiroot" \
81 && cp gitweb/*.png gitweb/*.css gitweb/*.js "$cfg_webroot")
84 echo "*** Setting up git-browser from git-browser.git..."
85 if [ ! -f git-browser.git/git-browser.cgi ]; then
86 echo "ERROR: git-browser.git is not checked out! Did you _REALLY_ read INSTALL?" >&2
87 exit 1;
89 mkdir -p "$cfg_webroot"/git-browser "$cfg_cgiroot"
90 (cd git-browser.git && cp git-browser.cgi "$cfg_cgiroot" \
91 && cp -r *.html *.js *.css js.lib/ JSON/ "$cfg_webroot"/git-browser)
92 ln -sf "$cfg_webroot/git-browser/JSON" "$cfg_cgiroot"
93 cat >"$cfg_cgiroot"/git-browser.conf <<EOT
94 gitbin: $cfg_git_bin
95 warehouse: $cfg_reporoot
96 EOT
97 cat >"$cfg_webroot"/git-browser/GitConfig.js <<EOT
98 cfg_gitweb_url="$cfg_gitweburl/"
99 cfg_browsercgi_url="$cfg_webadmurl/git-browser.cgi"
103 echo "*** Setting up darcs-fast-export from bzr-fastimport.git..."
104 if [ ! -d bzr-fastimport.git/exporters/darcs/ ]; then
105 echo "ERROR: bzr-fastimport.git is not checked out! Did you _REALLY_ read INSTALL?" >&2
106 exit 1;
108 mkdir -p "$cfg_basedir"/bin
109 cp bzr-fastimport.git/exporters/darcs/darcs-fast-export "$cfg_basedir"/bin
112 echo "*** Setting up our part of the website..."
113 mkdir -p "$cfg_webroot" "$cfg_cgiroot"
114 cp cgi/*.cgi gitweb/gitweb_config.perl "$cfg_cgiroot"
115 ln -fs "$cfg_basedir"/Girocco "$cfg_cgiroot"
116 [ -z "$cfg_webreporoot" ] || { rm -f "$cfg_webreporoot" && ln -s "$cfg_reporoot" "$cfg_webreporoot"; }
117 cp gitweb/indextext.html "$cfg_webroot"
118 mv "$cfg_basedir"/html/*.css "$cfg_basedir"/html/*.js "$cfg_webroot"
119 cp mootools.js "$cfg_webroot"
120 cp htaccess "$cfg_webroot/.htaccess"
121 cat gitweb/gitweb.css >>"$cfg_webroot"/gitweb.css